// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package internetmonitor provides the client and types for making API
// requests to Amazon CloudWatch Internet Monitor.
//
// Amazon CloudWatch Internet Monitor provides visibility into how internet
// issues impact the performance and availability between your applications
// hosted on Amazon Web Services and your end users. It reduces the time it
// takes for you to diagnose internet issues from days to minutes. Internet
// Monitor uses the connectivity data that Amazon Web Services captures from
// its global networking footprint to calculate a baseline of performance and
// availability for internet traffic. This is the same data that Amazon Web
// Services uses to monitor internet uptime and availability. With those measurements
// as a baseline, Internet Monitor raises awareness for you when there are significant
// problems for your end users in the different geographic locations where your
// application runs.
//
// Internet Monitor publishes internet measurements to CloudWatch Logs and CloudWatch
// Metrics, to easily support using CloudWatch tools with health information
// for geographies and networks specific to your application. Internet Monitor
// sends health events to Amazon EventBridge so that you can set up notifications.
// If an issue is caused by the Amazon Web Services network, you also automatically
// receive an Amazon Web Services Health Dashboard notification with the steps
// that Amazon Web Services is taking to mitigate the problem.
//
// To use Internet Monitor, you create a monitor and associate your application's
// resources with it, VPCs, CloudFront distributions, or WorkSpaces directories,
// to enable Internet Monitor to know where your application's internet traffic
// is. Internet Monitor then provides internet measurements from Amazon Web
// Services that are specific to the locations and networks that communicate
// with your application.
//
// For more information, see Using Amazon CloudWatch Internet Monitor (https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/CloudWatch-InternetMonitor.html)
// in the Amazon CloudWatch User Guide.
//
// See https://docs.aws.amazon.com/goto/WebAPI/internetmonitor-2021-06-03 for more information on this service.
//
// See internetmonitor package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/internetmonitor/
//
// # Using the Client
//
// To contact Amazon CloudWatch Internet Monitor with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon CloudWatch Internet Monitor client InternetMonitor for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/internetmonitor/#New
package internetmonitor
