// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package mediapackagev2 provides the client and types for making API
// requests to AWS Elemental MediaPackage v2.
//
// This guide is intended for creating AWS Elemental MediaPackage resources
// in MediaPackage Version 2 (v2) starting from May 2023. To get started with
// MediaPackage v2, create your MediaPackage resources. There isn't an automated
// process to migrate your resources from MediaPackage v1 to MediaPackage v2.
//
// The names of the entities that you use to access this API, like URLs and
// ARNs, all have the versioning information added, like "v2", to distinguish
// from the prior version. If you used MediaPackage prior to this release, you
// can't use the MediaPackage v2 CLI or the MediaPackage v2 API to access any
// MediaPackage v1 resources.
//
// If you created resources in MediaPackage v1, use video on demand (VOD) workflows,
// and aren't looking to migrate to MediaPackage v2 yet, see the MediaPackage
// v1 Live API Reference (https://docs.aws.amazon.com/mediapackage/latest/apireference/what-is.html).
//
// This is the AWS Elemental MediaPackage v2 Live REST API Reference. It describes
// all the MediaPackage API operations for live content in detail, and provides
// sample requests, responses, and errors for the supported web services protocols.
//
// We assume that you have the IAM permissions that you need to use MediaPackage
// via the REST API. We also assume that you are familiar with the features
// and operations of MediaPackage, as described in the AWS Elemental MediaPackage
// User Guide.
//
// See https://docs.aws.amazon.com/goto/WebAPI/mediapackagev2-2022-12-25 for more information on this service.
//
// See mediapackagev2 package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/mediapackagev2/
//
// # Using the Client
//
// To contact AWS Elemental MediaPackage v2 with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Elemental MediaPackage v2 client MediaPackageV2 for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/mediapackagev2/#New
package mediapackagev2
